- Qt 5.5
- Qt Quick
- Scene Graph - OpenGL Under QML
- squircle.h Example File
- Qt 5.5.1 Reference Documentation

# squircle.h Example File

scenegraph/openglunderqml/squircle.h

    /****************************************************************************
    **
    ** Copyright (C) 2015 The Qt Company Ltd.
    ** Contact: http://www.qt.io/licensing/
    **
    ** This file is part of the demonstration applications of the Qt Toolkit.
    **
    ** $QT_BEGIN_LICENSE:LGPL21$
    ** Commercial License Usage
    ** Licensees holding valid commercial Qt licenses may use this file in
    ** accordance with the commercial license agreement provided with the
    ** Software or, alternatively, in accordance with the terms contained in
    ** a written agreement between you and The Qt Company. For licensing terms
    ** and conditions see http://www.qt.io/terms-conditions. For further
    ** information use the contact form at http://www.qt.io/contact-us.
    **
    ** GNU Lesser General Public License Usage
    ** Alternatively, this file may be used under the terms of the GNU Lesser
    ** General Public License version 2.1 or version 3 as published by the Free
    ** Software Foundation and appearing in the file LICENSE.LGPLv21 and
    ** LICENSE.LGPLv3 included in the packaging of this file. Please review the
    ** following information to ensure the GNU Lesser General Public License
    ** requirements will be met: https://www.gnu.org/licenses/lgpl.html and
    ** http://www.gnu.org/licenses/old-licenses/lgpl-2.1.html.
    **
    ** As a special exception, The Qt Company gives you certain additional
    ** rights. These rights are described in The Qt Company LGPL Exception
    ** version 1.1, included in the file LGPL_EXCEPTION.txt in this package.
    **
    ** $QT_END_LICENSE$
    **
    ****************************************************************************/

    #ifndef SQUIRCLE_H
    #define SQUIRCLE_H

    #include <QtQuick/QQuickItem>
    #include <QtGui/QOpenGLShaderProgram>
    #include <QtGui/QOpenGLFunctions>

    class SquircleRenderer : public QObject, protected QOpenGLFunctions
    {
        Q_OBJECT
    public:
        SquircleRenderer() : m_t(0), m_program(0) { }
        ~SquircleRenderer();

        void setT(qreal t) { m_t = t; }
        void setViewportSize(const QSize &size) { m_viewportSize = size; }

    public slots:
        void paint();

    private:
        QSize m_viewportSize;
        qreal m_t;
        QOpenGLShaderProgram *m_program;
    };

    class Squircle : public QQuickItem
    {
        Q_OBJECT
        Q_PROPERTY(qreal t READ t WRITE setT NOTIFY tChanged)

    public:
        Squircle();

        qreal t() const { return m_t; }
        void setT(qreal t);

    signals:
        void tChanged();

    public slots:
        void sync();
        void cleanup();

    private slots:
        void handleWindowChanged(QQuickWindow *win);

    private:
        qreal m_t;
        SquircleRenderer *m_renderer;
    };

    #endif // SQUIRCLE_H